--Best = 343

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local file = require('scenario/cargames/fileHandler')
local helper = require('scenario/scenariohelper')
local targetTime = 0
local targetScore = -1
local targets = {}

local function onRaceStart()
	if not start then start = true end
end

local function success(score, targetsPoints, timePoints)
	local medal, nextMedal
	if score < 100 then 
		medal = 'None'
		nextMedal = 'Bronze(100)'
	elseif score >= 100 and score < 150 then 
		medal = 'Bronze'
		nextMedal = 'Silver(170)'
	elseif score >= 150 and score < 170 then 
		medal = 'Silver'
		nextMedal = 'Gold(190)'
	elseif score >= 190 and score < 210 then 
		medal = 'Gold'
		nextMedal = 'Platinum(210)'
	elseif score >= 210 and score < 250 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(250)'
	elseif score >= 250 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(4, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: ('..targetsPoints..'+'..timePoints..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	local targetsPoints = scoreFinal
	local timePoints = 60-scenarioTime
	scoreFinal = math.max(0, math.floor(scoreFinal+(60-scenarioTime)))
	success(scoreFinal, targetsPoints, timePoints)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'fallen' then scenario_scenarios.finish({failed = 'You fell off the course!'})
	elseif data.triggerName == 'finish' then finish()
	elseif data.event == 'enter' then
		local enteredBefore = false
		for key, value in ipairs(targets) do
			if value == data.triggerName then enteredBefore = true end 
		end
		
		if not enteredBefore then
			local targetPts = tonumber(string.match(data.triggerName, '%d+'))
			table.insert(targets, data.triggerName)
			targetTime = 0.25
			targetScore = targetScore+targetPts
			scoreFinal = scoreFinal+targetPts
		end
	end
end

local function onRaceTick(raceTickTime) 
	scenarioTime = scenarioTime+raceTickTime 
	if targetTime > 0 then targetTime = targetTime-raceTickTime
	elseif targetScore ~= -1 then
		helper.flashUiMessage(''..(targetScore+1)..' pts', 2)
		targetScore = -1
	end
	
	ui_message('Points: '..scoreFinal, 1, 'A')
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
return M