--Best = 778

local M = {}

local scoreLand = 0
local distance = 0
local snakeDistance = 0
local reset = true
local file = require('scenario/cargames/fileHandler')

local function success(score)
	local medal, nextMedal
	if score < 200 then 
		medal = 'None'
		nextMedal = 'Bronze(200)'
	elseif score >= 200 and score < 400 then 
		medal = 'Bronze'
		nextMedal = 'Silver(400)'
	elseif score >= 400 and score < 500 then 
		medal = 'Silver'
		nextMedal = 'Gold(500)'
	elseif score >= 500 and score < 575 then 
		medal = 'Gold'
		nextMedal = 'Platinum(575)'
	elseif score >= 575 and score < 625 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(625)'
	elseif score >= 625 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(24, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'fallen' then scenario_scenarios.finish({failed = 'You fell off the course!'}) end
end

local function onRaceTick(raceTickTime)
	local scenario_playerObject = scenetree.findObject('scenario_player')
	distance = math.max(0, math.floor(scenario_playerObject:getPosition().y-1667))
	
	if scenario_playerObject:getPosition().z <= 215 then success(distance) end
end

local function onScenarioChange(sc)
	if sc.state == 'pre-running' then
		TorqueScript.eval([[
			sunsky.colorize = "0.309803993 0.643136978 0.380391985 1";
			sunsky.sunScale = "0.670588017 0.815685987 0.788235009 1";
		]])
	elseif sc.state == 'pre-start' then
		TorqueScript.eval([[
			sunsky.shadowDistance = "16000";
			theLevelInfo.visibleDistance = "40000";
			theLevelInfo.fogAtmosphereHeight = "400";
		]])
	end
end

M.onScenarioChange = onScenarioChange
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
return M