--Best =1675

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local file = require('scenario/cargames/fileHandler')
local helper = require('scenario/scenariohelper')
local crystalHandling = require('scenario/cargames/crystalHandler')
local particleHandler = require('scenario/cargames/particleMotion')
local targetTime = 0
local targetScore = -1
local particles = {["lava1_angle"] = 0, ["lava1_radius"] = 275, ["lava1_z"] = 430, ["lava2"] = 751, ["lava3_y"] = 868, ["lava3_z"] = 576, ["lava4_y"] = 868, ["lava4_z"] = 576}
local targets = {}

local function onRaceStart()
	if not start then start = true end
end

local function success(score, targetsPoints, timePoints)
	local medal, nextMedal
	if score < 600 then 
		medal = 'None'
		nextMedal = 'Bronze(600)'
	elseif score >= 600 and score < 800 then 
		medal = 'Bronze'
		nextMedal = 'Silver(800)'
	elseif score >= 800 and score < 950 then 
		medal = 'Silver'
		nextMedal = 'Gold(950)'
	elseif score >= 950 and score < 1000 then 
		medal = 'Gold'
		nextMedal = 'Platinum(1000)'
	elseif score >= 1000 and score < 1200 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(1200)'
	elseif score >= 1200 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(23, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: ('..targetsPoints..'+'..timePoints..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	local targetsPoints = scoreFinal
	local timePoints = (180-scenarioTime)*10
	scoreFinal = math.max(0, math.floor(scoreFinal+(180-scenarioTime)*10))
	success(scoreFinal, targetsPoints, timePoints)
end

local function onBeamNGTrigger(data)
	if string.find(data.triggerName, 'fallen') then 
		local scenario_playerObject = scenetree.findObject('scenario_player')
		scenario_playerObject:queueLuaCommand('fire.explodeVehicle()')
		scenario_playerObject:queueLuaCommand('beamstate.breakAllBreakgroups()')
		scenario_scenarios.finish({failed = 'You fell off the course!'})
	elseif data.triggerName == 'finish' then finish()
	elseif data.triggerName == 'crystal_pickup' and data.event == 'enter' then crystalHandling.pickupCrystal(9)
	elseif data.event == 'enter' and (data.triggerName ~= 'finish' and data.triggerName ~= 'crystal_pickup') then
		if string.match(data.triggerName, "reset") then TorqueScript.eval('scenario_player.rotation = "0 0 1 90";')
		else
			local enteredBefore = false
			for key, value in ipairs(targets) do
				if value == data.triggerName then enteredBefore = true end 
			end
			
			if not enteredBefore then
				local targetPts = tonumber(string.match(data.triggerName, '%d+'))
				table.insert(targets, data.triggerName)
				targetTime = 0.25
				targetScore = targetScore+targetPts
				scoreFinal = scoreFinal+targetPts
			end
		end
	end
end

local function onRaceTick(raceTickTime) 
	scenarioTime = scenarioTime+raceTickTime 
	if targetTime > 0 then targetTime = targetTime-raceTickTime
	elseif targetScore ~= -1 then
		helper.flashUiMessage(''..(targetScore+1)..' pts', 2)
		targetScore = -1
	end
	
	ui_message('Points: '..scoreFinal, 1, 'A')
end

local function onScenarioChange(scenario)
	if scenario.state == 'pre-running' then
		if not crystalHandling.spawnCrystal(9) then crystalHandling.removeCrystal() end
		TorqueScript.eval([[
			sunsky.colorize = "1 0 0.0352941006 1";
			sunsky.sunScale = "1 0.709803998 0 1";
		]])
	end
end

----Particles----

local function updateParticles()
	particles["lava1_angle"] = particles["lava1_angle"]+0.1
	
	if particles["lava1_radius"] > 10 then
		particles["lava1_radius"] = particles["lava1_radius"]-0.5
		particles["lava1_z"] = particles["lava1_z"]+0.5
	else
		particles["lava1_radius"] = 275
		particles["lava1_z"] = 430
	end
	
	x_1, y_1 = particleHandler.circular(particles["lava1_radius"], particles["lava1_angle"])

	particles["lava2"] = particles["lava2"]-5
	if particles["lava2"] < 176 then particles["lava2"] = 751 end
	
	particles["lava3_y"] = particles["lava3_y"]+3
	if particles["lava3_y"] > 206 then 
		particles["lava3_y"] = -868 
		particles["lava3_z"] = 576 
	elseif particles["lava3_y"] > -400 then particles["lava3_z"] = particles["lava3_z"]-math.sin(20)
	end	
	
	particles["lava4_y"] = particles["lava4_y"]+3
	if particles["lava4_y"] > 206 then 
		particles["lava4_y"] = -868 
		particles["lava4_z"] = 576 
	elseif particles["lava4_y"] > -400 then particles["lava4_z"] = particles["lava4_z"]-math.sin(20)
	end	
	
	TorqueScript.eval([[
		lava1.position = "]]..(-1101+x_1)..[[ ]]..(584+y_1)..[[ ]]..particles["lava1_z"]..[[";
		lava2.position = "-655.852783 ]]..particles["lava2"]..[[ 435.763428";
		lava3.position = "-448 ]]..particles["lava3_y"]..[[ ]]..particles["lava3_z"]..[[";
		lava4.position = "-724 ]]..particles["lava4_y"]..[[ ]]..particles["lava4_z"]..[[";
	]])
end

--------

local function onPreRender(dt)
	updateParticles()

	if crystalHandling.spawnCrystal(9) then crystalHandling.updateCrystal() end --Only render rotations of the crystal if it is necessary
end

M.onPreRender = onPreRender
M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange= onScenarioChange
return M