--Best = 1676

local M = {}

local speed = 0
local ramp = false
local rotation = 0
local file = require('scenario/cargames/fileHandler')
local crystalHandling = require('scenario/cargames/crystalHandler')

local function success(score, scoreSpeed, scoreDistance)
	local medal, nextMedal
	if score < 500 then 
		medal = 'None'
		nextMedal = 'Bronze(500)'
	elseif score >= 500 and score < 850 then 
		medal = 'Bronze'
		nextMedal = 'Silver(850)'
	elseif score >= 850 and score < 1100 then 
		medal = 'Silver'
		nextMedal = 'Gold(1100)'
	elseif score >= 1100 and score < 1400 then 
		medal = 'Gold'
		nextMedal = 'Platinum(1400)'
	elseif score >= 1400 and score < 1595 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(1595)'
	elseif score >= 1595 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(25, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: '..scoreDistance..'+'..scoreSpeed..' = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onRaceTick(raceTickTime)
	local scenario_playerData = map.objects[map.objectNames['scenario_player']]
	local distance = math.floor(scenetree.findObject('scenario_player'):getPosition().y-4572)
	
	if not ramp then 
		if speed < math.floor(scenario_playerData.vel:length()*10) then speed = math.floor(scenario_playerData.vel:length()*10) end
	end
	
	if scenetree.findObject('scenario_player'):getPosition().z <= 15 then success(math.max(0, speed+distance), speed, distance) end
end

local function onPreRender(dt)
	rotation = rotation+1
	TorqueScript.eval([[
		rotor1.rotation =  " 1 0 0 ]]..rotation      ..[[";
		rotor2.rotation =  "-1 0 0 ]]..(rotation*2)  ..[[";
		rotor3.rotation =  "-1 0 0 ]]..(rotation*6)  ..[[";
		rotor4.rotation =  "-1 0 0 ]]..(rotation*4)  ..[[";
		rotor5.rotation =  " 1 0 0 ]]..(rotation*1.5)..[[";
		rotor6.rotation =  "-1 0 0 ]]..(rotation*2)  ..[[";
		rotor7.rotation =  "-1 0 0 ]]..rotation      ..[[";
		rotor8.rotation =  " 1 0 0 ]]..(rotation*8)  ..[[";
		rotor9.rotation =  "-1 0 0 ]]..(rotation*2)  ..[[";
		rotor10.rotation = "-1 0 0 ]]..rotation      ..[[";
		rotor11.rotation = " 1 0 0 ]]..rotation      ..[[";
		rotor12.rotation = " 1 0 0 ]]..rotation      ..[[";
		rotor13.rotation = " 1 0 0 ]]..rotation      ..[[";
		rotor14.rotation = " 1 0 0 ]]..rotation      ..[[";
		rotor15.rotation = " 1 0 0 ]]..rotation      ..[[";
		saw1.rotation =    " 1 0 0 ]]..rotation      ..[[";
		saw2.rotation =    "-1 0 0 ]]..(rotation*3)  ..[[";
		saw3.rotation =    " 1 0 0 ]]..(rotation*2)  ..[[";
		saw4.rotation =    "-1 0 0 ]]..rotation      ..[[";
		saw5.rotation =    " 1 0 0 ]]..(rotation*7)  ..[[";
		saw6.rotation =    "-1 0 0 ]]..(rotation*11) ..[[";
	]])
end

local function onBeamNGTrigger(data)
	if data.event == 'enter' and data.triggerName == 'ramp' then ramp = true 
	elseif data.triggerName == 'fallen' then scenario_scenarios.finish({failed = 'You fell off the course!'})
	end
end

local function onScenarioChange(sc)
	if sc.state == 'pre-running' then
		TorqueScript.eval([[
			sunsky.colorize = "0.913725972 0.411765009 0.156863004 1";
			sunsky.sunScale = "0.662744999 0.321568996 0.00392156979 1";
		]])
	elseif sc.state == 'pre-start' then
		TorqueScript.eval([[
			sunsky.shadowDistance = "16000";
			theLevelInfo.visibleDistance = "40000";
			theLevelInfo.fogAtmosphereHeight = "400";
		]])
	end
end

M.onPreRender = onPreRender
M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
return M