--Best = 1090

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local targetScore = -1
local targetTime = 0
local file = require('scenario/cargames/fileHandler')
local helper = require('scenario/scenariohelper')
local crystalHandling = require('scenario/cargames/crystalHandler')
local targets = {}

local function onScenarioChange(scenario)
	if scenario.state == 'pre-running' then
		if not crystalHandling.spawnCrystal(6) then crystalHandling.removeCrystal() end
	elseif scenario.state == 'pre-start' then
		local scenario_playerObject = scenetree.findObject('scenario_player')
		scenario_playerObject:queueLuaCommand('obj:setGravity(-9.81)')
	end
end

local function success(score, targetsPoints, timePoints)
	local medal, nextMedal
	if score < 800 then 
		medal = 'None'
		nextMedal = 'Bronze(800)'
	elseif score >= 800 and score < 850 then 
		medal = 'Bronze'
		nextMedal = 'Silver(850)'
	elseif score >= 850 and score < 950 then 
		medal = 'Silver'
		nextMedal = 'Gold(950)'
	elseif score >= 950 and score < 1000 then 
		medal = 'Gold'
		nextMedal = 'Platinum(1000)'
	elseif score >= 1000 and score < 1030 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(1030)'
	elseif score >= 1030 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.setValueToSave(14, file.getMedalAsNumber(medal), 1)
	
    local result = {msg = 'Well Done! Your Score: ('..targetsPoints..'+'..timePoints..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	local targetsPoints = scoreFinal
	local timePoints = math.floor((150-scenarioTime)*10)
	local scenario_playerObject = scenetree.findObject('scenario_player')
	scenario_playerObject:queueLuaCommand('obj:setGravity(-9.81)')
	scoreFinal = scoreFinal+(150-scenarioTime)*10
	success(math.max(0, scoreFinal), targetsPoints, timePoints)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'fallen' then scenario_scenarios.finish({failed = 'You fell off the course!'})
	elseif data.triggerName == 'finish' then finish()
	elseif data.triggerName == 'crystal_pickup' and data.event == 'enter' then crystalHandling.pickupCrystal(6)
	elseif data.event == 'enter' then
		if data.triggerName == 'reset' then TorqueScript.eval('scenario_player.rotation = "0 0 1 90";')
		elseif string.find(data.triggerName, 'zeroGravity') then
			local scenario_playerObject = scenetree.findObject('scenario_player')
			scenario_playerObject:queueLuaCommand('obj:setGravity(0)')
		elseif string.find(data.triggerName, 'earthGravity') then
			local scenario_playerObject = scenetree.findObject('scenario_player')
			scenario_playerObject:queueLuaCommand('obj:setGravity(-9.81)')
		else
			local enteredBefore = false
			for key, value in ipairs(targets) do
				if value == data.triggerName then enteredBefore = true end 
			end
			
			if not enteredBefore then
				local targetPts = tonumber(string.match(data.triggerName, '%d+'))
				table.insert(targets, data.triggerName)
				targetTime = 0.25
				targetScore = targetScore+targetPts
				scoreFinal = scoreFinal+targetPts
			end
		end
	end
end

local function onRaceTick(raceTickTime)
	scenarioTime = scenarioTime+raceTickTime 
	
	if targetTime > 0 then targetTime = targetTime-raceTickTime
	elseif targetScore ~= -1 then
		helper.flashUiMessage(''..(targetScore+1)..' pts', 2)
		targetScore = -1
	end
	
	ui_message('Points: '..scoreFinal, 1, 'A')
end

local function onPreRender(dt)
	if crystalHandling.spawnCrystal(6) then crystalHandling.updateCrystal() end --Only render rotations of the crystal if it is necessary
end

M.onPreRender = onPreRender
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
return M